%define current_version 7.0.293

%define _basename libvzctl
%define _incdir /usr/include/vzctl
%define _pkglibdir %_libdir/libvzctl
%define _scriptdir %{_libexecdir}/%{name}/scripts
%define _scriptddir %{_libexecdir}/%{name}/script.d
%define _distconfdir %{_libexecdir}/%{name}/dists
%define _distscriptdir %{_distconfdir}/scripts

%{?coverage:%define _coverage %{coverage}}
%{!?coverage:%define _coverage 0}

%if %_coverage
Name: libvzctl-coverage
Provides: libvzctl
Obsoletes: libvzctl
%else
Name:		libvzctl
%endif
Summary:	Parallels Containers API library
Version:	%{current_version}
Release:        1%{?dist}
License:	LGPLv2.1
Group:		System Environment
Source:		%{name}-%{version}.tar.bz2
ExclusiveArch:	x86_64
ExclusiveOS: Linux
BuildRoot: %{_tmppath}/libvzctl-root
Requires:	libvzevent >= 5.0.0-4
Requires:	ploop-lib >= 7.0.58
Requires:	libcgroup-tools
Requires:	criu
Requires:	libvcmmd >= 7.0.10
BuildRequires:	libvzevent >= 5.0.0-4
BuildRequires:	libvzevent-devel >= 5.0.0-4
BuildRequires:  ploop-lib >= 7.0.58
BuildRequires:  ploop-devel >= 7.0.58
BuildRequires:  libvcmmd-devel >= 7.0.10
BuildRequires:  automake, libtool, libxml2-devel, libuuid-devel, vzkernel-headers dbus-devel
Obsoletes:      vzctl-lib

#%package
Summary:	Parallels Containers API library
Group:		System Environment

%description
Parallels Containers API library

%prep
%setup -n %{name}-%{version}
./autogen.sh
%if %_coverage
CFLAGS="-fprofile-arcs -ftest-coverage" LGCOV="-lgcov" %configure
%else
CFLAGS="$RPM_OPT_FLAGS" %configure --enable-static
%endif

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT/
%if %_coverage
mkdir -p ${RPM_BUILD_ROOT}/%_builddir/libvzctl
cp -a * ${RPM_BUILD_ROOT}/%_builddir/libvzctl
find ${RPM_BUILD_ROOT}/%_builddir/libvzctl -type f | xargs chmod 644
%endif
%{__mkdir} -p -p %{buildroot}%{_docdir}/%{name}-%{version}
install -m 644 COPYING LGPL-2.1  %{buildroot}%{_docdir}/%{name}-%{version}/
%{__mkdir} -p -p %{buildroot}%{_docdir}/%{name}-devel-%{version}
install -m 644 COPYING LGPL-2.1  %{buildroot}%{_docdir}/%{name}-devel-%{version}/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libvzctl2.so.*
%dir %{_pkglibdir}
%attr(755,root,root) %{_pkglibdir}/exec_wrap
%dir %{_scriptdir}
%{_scriptdir}/vz-cpt-action
%{_scriptdir}/vz-cpt
%{_scriptdir}/vz-create_prvt
%{_scriptdir}/vz-functions
%{_scriptdir}/vznetcfg
%{_scriptdir}/vz-net_add
%{_scriptdir}/vz-net_del
%{_scriptdir}/vz-netns_dev_add
%{_scriptdir}/vz-netns_dev_del
%{_scriptdir}/vz-pci_configure
%{_scriptdir}/vz-postinst
%{_scriptdir}/vz-rst-action
%{_scriptdir}/vz-rst
%{_scriptdir}/vz-setrate
%{_scriptdir}/vz-start
%{_scriptdir}/vz-stop
%{_scriptdir}/vz-announce_ips
%dir %{_scriptddir}
%{_scriptddir}/README
%dir %{_distconfdir}
%{_distconfdir}/default
%config(noreplace) %{_distconfdir}/*.conf
%{_distscriptdir}/*.sh
%{_distscriptdir}/functions
%{_docdir}/%{name}-%{version}
%if %_coverage
%{_builddir}/libvzctl
%endif

%package devel
Summary: Parallels Containers API development library
Group: System Environment/Kernel
License:	LGPLv2.1
Requires: %{name}  = %{version}-%{release}
%description devel
Parallels Containers API development library

%if ! %_coverage
%files devel
%{_docdir}/%{name}-devel-%{version}
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libvzctl2.so
%attr(755,root,root) %{_libdir}/libvzctl2.la
%attr(644,root,root) %{_incdir}/*.h
%attr(755,root,root) %{_libdir}/libvzctl2.a

%{debug_package}
%endif


%changelog
* Wed Oct 05 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.293
 - umount_all: skip processing if image does not exist
 - vzctl_encrypt_disk_image: do not pass pfcache mount options

* Mon Oct 03 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.292
 - set_fs_uuid: not correct partition device name for encrypted image
 - fix attach block device

* Mon Oct 03 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.291
 - vz-*-action: line 97: [: : integer expression expected #PSBM-52916
 - Can't start CT with attached block device #PSBM-52968

* Fri Sep 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.289
 - Call library init from constructor

* Thu Sep 22 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.288
 - Get network iface info #PSBM-52444

* Wed Sep 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.287
 - Exec distribution action script

* Fri Sep 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.286
 - Bad parameter for --memguarantee: #PSBM-52228

* Thu Sep 15 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.285
 - Disk encryption support encrypt/decrypt/changekey #PSBM-52087

* Tue Sep 13 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.284
 - Pagecache isolation configuration parameter #PSBM-32384

* Mon Sep 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.283
 - set_disk_param: fixed using VZCTL_CONF_USE_RELATIVE_PATH

* Mon Sep 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.282
 - do_wrap_env_exec_script: failed to set ip address on running CT

* Mon Sep 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.281
 - load_disk_info: NULL dereference

* Mon Sep 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.280
 - vzctl2_env_get_disk_param: fill encryption keyid

* Mon Sep 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.279
 - vzctl2_env_exec_script: remove extara CTID.conf parse
 - read_script: memleak on error path
 - Add VZCTL_CONF_LOAD_DISK_INFO flag on parse CT configuration

* Fri Sep 09 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.278
 - Create dirs with 0700 perms, see #PSBM-51897

* Fri Sep 09 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.277
 - The swap size mismatches expected #PSBM-51783

* Fri Sep 09 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.276
 - Second level quota does not work for encrypted CT #PSBM-51904

* Thu Sep 08 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.275
 - suse-add_netif.sh: fix typo #PSBM-51863
 - get_ploop_disk_stats(): fixed fill device name

* Thu Sep 08 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.274
 - Failed to resume CT #PSBM-51856

* Wed Sep 07 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.273
 - Second level quota does not work for encrypted CT #PSBM-51803
 - Restart wickedd more carefully in OpenSUSE guests #PSBM-50911

* Tue Sep 06 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.272
 - CT autostop functionality #PSBM-50873
 - Ignore non-local containers in vzctl2_get_env_ids_by_state #PSBM-51253
 - get_vcmm_config(): Uninitialized scalar variable (UNINIT)
 - find_disk_by_fsuuid(): Array compared against 0 (NO_EFFECT)

* Mon Sep 05 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.271
 - Docker installed into Ubuntu 16.04 brokes CT enter #PSBM-51712

* Fri Sep 02 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.270
 - env_nsops.c: handle EINTR error on read() #PSBM-51667

* Thu Sep 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.269
 - Enable "bridge" feature by default for Containers #PSBM-50520

* Thu Sep 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.268
 - vzctl2_env_get_veth_param(): network type is not reported #PSBM-51668

* Thu Sep 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.267
 - Encrypted image is not mounted on CT start #PSBM-51628
 - env_configure_disk: display error on mknod failure
 - Display error messagr on CT resume failure #PSBM-51512

* Thu Sep 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.266
 - vzctl2_env_set_veth_param: unable to set VZCTL_NETTYPE_BRIDGE #PSBM-51654

* Wed Aug 31 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.265
 - Connect veth adapter to bridge #PSBM-51448

* Tue Aug 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.264
 - Failed to create encrypted CT #PSBM-51551

* Fri Aug 26 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.263
 - Skip template management on CT creation #PSBM-32832

* Fri Aug 26 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.262
 - rm_tree(): fix result check #PSBM-51414

* Thu Aug 25 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.261
 - Can't stop a container with a lot of nested cgroups #PSBM-49914

* Tue Aug 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.260
 - Pass mount option to ploop_encrypt_image #PSBM-51074
 - Delete unmounted ploop image resulted to crash #PSBM-51230

* Mon Aug 22 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.259
 - Prohibit using of pfcache for encrypted ploops #PSBM-50722
 - parse_range(): fixed strtoul() result check

* Fri Aug 19 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.258
 - Add debug logging of killed Ct processes #PSBM-51134

* Thu Aug 18 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.257
 - Unable to start CT wit misconfigured attached backups #PSBM-51106
 - scripts: c/r kernel.pid_max sysctl from CT root pidns #PSBM-48397

* Tue Aug 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.256
 - get_ploop_disk_stats(): fixed array size calculation #PSBM-50945

* Mon Aug 15 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.255
 - Disk encryption support #PSBM-49430

* Fri Aug 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.254
 - IO limit support for process #PSBM-50919
 - Re-add functionality for EXTERNAL_SCRIPT support from legacy codebase.

* Tue Aug 09 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.253
 - Export vzctl2_unescapestr_eq() #PSBM-50877

* Tue Aug 09 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.252
 - Failed to resume CT with enable 2nd quota #PSBM-50819
 - save criu logs irrespective of criu ret code #PSBM-49518

* Thu Aug 04 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.251
 - get_ploop_disk_stats(): skip auto mount ploop #PSBM-50624

* Thu Aug 04 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.250
 - vz-rst: temove spfs scripts from criu restore parameters
 - scripts: vz-cpt.in -- Pass controllers to dump in options
 - scripts: vz-rst-action -- Use env variable instead of pidfile value (#PSBM-50551)
 -  Prevent NetworkManager from breaking network in RH-based containers #PSBM-50617
 - Mount /dev with strict options as systemd does, see #PSBM-50536

* Mon Aug 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.249
 - get_ploop_disk_stats(): Skip get disk stat for devices #PSBM-49710

* Fri Jul 29 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.248
 - save criu logs irrespective of criu ret code #PSBM-49518

* Thu Jul 28 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.247
 - Deny enter action if CT in suspending transition state #PSBM-50143

* Wed Jul 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.246
 - Change CT name on register action #PSBM-50026

* Mon Jul 25 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.245
 - Cant detach ploop image mounted inside CT #PSBM-49606

* Thu Jul 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.244
 - device is listed in devices.list after online HDD detach #PSBM-49678
\#PSBM-49947

* Tue Jul 19 2016 Denis Silakov <dsilakov@virtuozzo.com> 7.0.243-2
 - Obsolete vzctl-lib from Vz6, see #PSBM-49624
 
* Tue Jul 19 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.243
 - bindmounts in CT cpuset cgroup which should be hidden #PSBM-49826

* Fri Jul 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.242
 - get_slice_name: ability to customize CT slice name #PSBM-49202

* Tue Jun 28 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.241
 - Failed to start CT if OS template is not installed #PSBM-48952

* Mon Jun 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.240
 - Set debug loglevel for criu #PSBM-48923
 - vz-setrate.in: reconfigure shaper on shepron action #PSBM-42178

* Fri Jun 24 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.239
 - Failed to start CT with turned on userquota #PSBM-48835

* Fri Jun 24 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.238
 - Create image snapshot before resume CT processes #PSBM-48810

* Thu Jun 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.237
 - Mount secondary ploop inside CT on resume #PSBM-48188

* Thu Jun 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.236
 - Use new cgroup based API to set mount perm #PSBM-48188
 - Deny to start CT without root disk #PSBM-48762

* Wed Jun 22 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.235
 - remount CT root host mount as SLAVE #PSBM-46298

* Tue Jun 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.234
 - Send VZCTL_ENV_SUSPENDED event on CT suspend #PSBM-47191

* Tue Jun 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.233
 - Make config option to not delete cgroup during CT stopping #PSBM-48394

* Tue Jun 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.232
 - destroydir(): remove inplace on any error #PSBM-48604
 - place container cgroups under machine.slice #PSBM-48425

* Thu Jun 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.231
 - Adding secondary disk to simfs based CT broke CT start #PSBM-48398
 - vzctl2_env_get_disk_stats(): surpress Unsupported CT layout erro #PSBM-48398
 - Increase default timeout for criu dump, #PSBM-48256

* Wed Jun 15 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.230
 - Specify quota format on the command line for quotacheck. #PSBM-47292
 - Skip app templates installation present in cache on CT creation #PSBM-48338
 - Skip unmount image if it was not mounted #PSBM-48247

* Thu Jun 09 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.229
 - Enumerate non-root ploop devices as external in criu options #PSBM-47221

* Wed Jun 08 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.228
 - Failed to dump CT #PSBM-48137

* Wed Jun 08 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.227
 - VCPU number is reset after setting cpu limit #PSBM-48061

* Tue Jun 07 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.226
 - Drop user quota limits on stopped CT #PSBM-47824

* Mon Jun 06 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.225
 - Create image snapshot before resume CT processes #PSBM-47920
 - do_dump(): access buffer out of bounds

* Fri Jun 03 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.224
 - CPU limit is not capped by number of CPUs #PSBM-46368

* Fri Jun 03 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.223
 - Report CT start failures due to incorrect limit configuration v2 #PSBM-43409
 - Fixed secondary disk size specification in ve.conf (Dmitry Mishin

* Wed Jun 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.222
 - Failed to destroy CT #PSBM-47841

* Wed Jun 01 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.221
 - Failed to resume CT #PSBM-47753

* Tue May 31 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.220
 - Config is not reverted on snapshot-switch action #PSBM-47752

* Mon May 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.219
 - create ploop block device file in '/dev' #PSBM-47634
 - setup_devtmpfs(): use premounted '/dev' as devtmpfs inside CT

* Fri May 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.218
 - add ploop device major:minor info to umoutn event #PSBM-47407
 - Pass VZ_PROGRESS_FD environment variable to vzpkg 
 - Can't mount file system: Invalid argument #PSBM-47615

* Fri May 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.217
 - Failed to delete secondary disk on running CT #PSBM-47563
 - scripts: add /usr/libexec/criu/scripts/spfs-release-replace.sh to vz-rst

* Wed May 25 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.216
 - Can't detach real disk on running ct #PSBM-46803
 - scripts: vz -- Handle optional VZ images without error exit (#PSBM-47359)

* Mon May 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.215
 - vzctl2_env_register(): name is changed on force registration #PSBM-46904

* Mon May 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.214
 - Mount CT /sys and its contents as shared filesystem #PSBM-46985
 - Fix ip set on suse CT with wicked. #PSBM-47344 

* Fri May 20 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.213
 - Unable to create ostempalet cache #PSBM-47181

* Fri May 20 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.212
 - Unable to create ostempalet cache #PSBM-47181
 - Backport env_configure_udev_rules from Vz6, #PSBM-46873

* Thu May 19 2016 Igor Sukhih <igor@parallels.com> 7.0.211
 - env setup: allow fuse device on start
 - vz-cpt: NFS port allow script added
 - vz-rst: SPFS to stub mode script added

* Wed May 18 2016 Igor Sukhih <igor@parallels.com> 7.0.210
 - scripts: Save and restore missing VE properties #PSBM-46811
 - Fix route adding logic for Suse. #PSBM-47073

* Wed May 04 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.209
 - Forward correct verbosity to criu restore during live migration, #PSBM-46597
(Nikita Spiridonov <nspiridonov@virtuozzo.com>)
 - Fix read of swap data from core. #PSBM-46695 (Alexander Pisarev
<apisarev@virtuozzo.com>)

* Fri Apr 29 2016 Igor Sukhih <igor@parallels.com> 7.0.208
 - ndsend core dumped #PSBM-46694

* Fri Apr 29 2016 Igor Sukhih <igor@parallels.com> 7.0.207
 - Vzctl restore speed improvemen
 - Decrease delay in parallels_execution function #PSBM-46211

* Thu Apr 28 2016 Igor Sukhih <igor@parallels.com> 7.0.206
 - Container don't unregistered on SRCafter successfull shared migration #PSBM-46669
 - Drop write to memory.kmem.limit_in_bytes on container start

* Thu Apr 28 2016 Igor Sukhih <igor@parallels.com> 7.0.205
 - Functionality to get traffic classes net statistics #PSBM-46103
 - Fix mask parser for cpu and node mask. #PSBM-35208

* Wed Apr 27 2016 Igor Sukhih <igor@parallels.com> 7.0.204
 - Report CT start failures due to incorrect limit configuration #PSBM-43409
 - Report the "Address already in use" specific error #PSBM-33726

* Sat Apr 23 2016 Igor Sukhih <igor@parallels.com> 7.0.203
 - Read pfcache parameters from /etc/vz/pfcache.conf #PSBM-45513

* Fri Apr 22 2016 Igor Sukhih <igor@parallels.com> 7.0.202
 - Send pre umount event on umount action #PSBM-45952
 - Add error message on try to set unsupported cpumask. #PSBM-46467

* Tue Apr 19 2016 Igor Sukhih <igor@parallels.com> 7.0.201
 - Allow access to /dev/autofs inside CT #PSBM-41218

* Mon Apr 18 2016 Igor Sukhih <igor@parallels.com> 7.0.200
 - Unable to start a Container if the respective EZ template is not installed #PSBM-43110
 - Fix vz-rst script logging, #PSBM-4564

* Sat Apr 16 2016 Igor Sukhih <igor@parallels.com> 7.0.199
 - functionality to spicify setmode

* Sat Apr 16 2016 Igor Sukhih <igor@parallels.com> 7.0.198
 - killing of 'vzctl exec2' doesn't kill subprocesses #PSBM-38702
 - file descriptors are not closed on entering into namespaces #PSBM-44524

* Sat Apr 16 2016 Igor Sukhih <igor@parallels.com> 7.0.197
 - scripts: vz-rst -- Add action scripts for AutoFS sake (#PSBM-46249)

* Fri Apr 15 2016 Igor Sukhih <igor@parallels.com> 7.0.196
 - incorrect behavior for DEVNODES parameter on applying config #PSBM-34160

* Wed Apr 13 2016 Igor Sukhih <igor@parallels.com> 7.0.195
 - Failed to Start CT: "Can't make slave: Invalid argument" #PSBM-44377
 - vzctl2_env_unreg(): remove CTID.conf if VE_PRIVATE does not exists #PSBM-42465
 - Confusing error message when trying to create CT from unexisting OS template
#PSBM-44415

* Tue Apr 12 2016 Igor Sukhih <igor@parallels.com> 7.0.194
 - Set cpu limit setup via cpu.cfs_quota_us instead of cpu.rate #PSBM-41313

* Tue Apr 12 2016 Igor Sukhih <igor@parallels.com> 7.0.193
 - Moving physical net interfaces inside a CT #PSBM-40537

* Mon Apr 11 2016 Igor Sukhih <igor@parallels.com> 7.0.192
 - Do not fail CT register if name already used #PSBM-13370

* Mon Apr 11 2016 Igor Sukhih <igor@parallels.com> 7.0.191
 - scripts: vz_ -- Checkpoint and restore AIO staistics #PSBM-45644
 - A criu log level should depend on a vzctl log level #PSBM-45175
 - scripts: vz_ -- Checkpoint and restore clock offsets #PSBM-41406,#PSBM-45631

* Fri Apr 01 2016 Igor Sukhih <igor@parallels.com> 7.0.190
 - Failed to mount image #PSBM-45691

* Thu Mar 31 2016 Igor Sukhih <igor@parallels.com> 7.0.189
 - Failed to start CT with secondary ploop and pfcache enabled #PSBM-45647
 - create_static_dev(): full path in devnode parameter is dropped #PSBM-45632

* Wed Mar 30 2016 Igor Sukhih <igor@parallels.com> 7.0.188
 - Provide cancelation API

* Wed Mar 30 2016 Igor Sukhih <igor@parallels.com> 7.0.187
 - Switch to the new libvcmmd API

* Mon Mar 28 2016 Igor Sukhih <igor@parallels.com> 7.0.186
 - vzctl2_add_disk: skip disk image creation for storage_url type

* Thu Mar 24 2016 Igor Sukhih <igor@parallels.com> 7.0.185
 - CT name dropped on register
 - Set ve.state before droping pseudosuper #PSBM-44981
 - env_nsops: Use @pseudosuper feature on CT start #PSBM-44981
 - Add helper to write data to file by fd #PSBM-44981

* Tue Mar 15 2016 Igor Sukhih <igor@parallels.com> 7.0.184
 - scripts: vz-cpt -- Increase the limit for fds (#PSBM-44887)
 - Can't create container on shared storage #PSBM-45002

* Fri Mar 11 2016 Igor Sukhih <igor@parallels.com> 7.0.183
 - CT c/r kernel.core_pattern in criu action scripts #PSBM-44145

* Wed Mar 09 2016 Igor Sukhih <igor@parallels.com> 7.0.182
 - Functionalit to create ploop major:minor map #PSBM-44417
 - do_env_stop(): process M_KILL_FORCE mode

* Wed Mar 09 2016 Igor Sukhih <igor@parallels.com> 7.0.181
 - do_env_stop(): process M_KILL_FORCE mode

* Wed Feb 24 2016 Igor Sukhih <igor@parallels.com> 7.0.180
 - Verify VE_PRIVATE validity before destroying container #PSBM-44077
 - ns_apply_res_param: skip store guarantee parameters on error #PSBM-44358
 - vzctl2_apply_param() exit with 0 on error #PSBM-44358

* Wed Feb 10 2016 Igor Sukhih <igor@parallels.com> 7.0.179
 - setup_devtmpfs() : incorrect mode for /dev/null #PSBM-43924

* Tue Feb 09 2016 Igor Sukhih <igor@parallels.com> 7.0.178
 - setup_devtmpfs() : incorrect mode for /dev/null #PSBM-43924
 - Run scripts on bash

* Thu Feb 04 2016 Igor Sukhih <igor@parallels.com> 7.0.177
 - Unable to start unlimited CT #PSBM-43671
 - Set device permission for secondary disk on CT resume
 - Typo in message fixed (Sergey Bronnikov <sergeyb@openvz.org>)

* Tue Feb 02 2016 Igor Sukhih <igor@parallels.com> 7.0.176
 - Failed to dump CT #PSBM-43755

* Mon Feb 01 2016 Igor Sukhih <igor@parallels.com> 7.0.175
 - Failed to switch to snapshot #PSBM-42561
 - move wait/err control pipes to vzctl_runtime_ctx
 - added struct vzctl_runtime_ctx storage
 - Added hdd was not mounted to specified mount point #PSBM-43706
 - Remove bash' 'let' from vz-rst-action 

* Sat Jan 30 2016 Igor Sukhih <igor@parallels.com> 7.0.174
 - Do not use criu '--ext-mount-map auto' feature for c/r #PSBM-43260

* Thu Jan 28 2016 Igor Sukhih <igor@parallels.com> 7.0.173
 - Recalculate memguarantee on physpages update

* Wed Jan 27 2016 Igor Sukhih <igor@parallels.com> 7.0.172
 - Failed to add secondary disk by device
 - increase default ghost-limit restriction 5Mb -> 50Mb #PSBM-42013

* Tue Jan 26 2016 Igor Sukhih <igor@parallels.com> 7.0.171
 - vz-rst-action.in: ploop minor is not restored

* Mon Jan 25 2016 Igor Sukhih <igor@parallels.com> 7.0.170
 - Memory guaranty #PSBM-43142

* Mon Jan 25 2016 Igor Sukhih <igor@parallels.com> 7.0.169
 - Make SYSTEMD_CTID_x be plain veids for restore convenience #PSBM-43256
 - cgroup: Add missing controllers into the set #PSBM-43256
 - bindmount_env_cgroup(): return error on failure
 - is_prvt_cgroup(): treat unknown cgroup as private
 - vzctl2_env_chkpnt: skip running post stop sctipt on suspend failure

* Thu Jan 21 2016 Igor Sukhih <igor@parallels.com> 7.0.168
 - Unable to create simfs based CT #PSBM-43277

* Thu Jan 21 2016 Igor Sukhih <igor@parallels.com> 7.0.167
 - Failed to start CT with disk as real device #PSBM-43177

* Thu Jan 21 2016 Igor Sukhih <igor@parallels.com> 7.0.166
 - vz-rst-action.in -- Get back @pseudosuper release

* Wed Jan 20 2016 Igor Sukhih <igor@parallels.com> 7.0.165
 - Unable to start a container from block device #PSBM-43177 (root
<root@dhcp-10-30-30-187.sw.ru>)
 - fs_is_mounted_check_by_target(): incorrect sscanf() result check
 - fs_is_mounted_check_by_target: memleak on error path
 - CT restore failed if ploop device minor is changed #PSBM-42672
 - Failed to resume CT
 - env_nsops: Use @pseudosuper feature on the restore procedure (#PSBM-34299 #PSBM-43169 #PSBM-42573)
 - vzctl2_env_restore: fixed double fd close

* Mon Jan 18 2016 Igor Sukhih <igor@parallels.com> 7.0.164
 - env_nsops: Use @pseudosuper feature on the restore procedure (#PSBM-34299 #PSBM-43169 #PSBM-42573)
 - vzctl2_env_restore: fixed double fd close

* Wed Jan 13 2016 Igor Sukhih <igor@parallels.com> 7.0.163
 - vcmm.c: fixed compilation

* Wed Jan 13 2016 Igor Sukhih <igor@parallels.com> 7.0.162
 - vcmm.c: switch to libvcmmd-7.0.4
 - vcmm.c: added vcmmd prefix to error message
 - vcmm_unregister: skip VCMMD_ERROR_VE_NOT_REGISTERED error

* Mon Jan 11 2016 Igor Sukhih <igor@parallels.com> 7.0.161
 - Unregister a container from vcmmd #PSBM-42820
 - lib/env.c: setup_devtmpfs -- Don't miss tty12 device #PSBM-41628

* Mon Jan 11 2016 Igor Sukhih <igor@parallels.com> 7.0.160
 - Cleanup CT resources on force stop action #PSBM-42820

* Fri Dec 25 2015 Igor Sukhih <igor@parallels.com> 7.0.159
 - vzctl2_env_create_snapshot: change stage order #PSBM-42561

* Fri Dec 25 2015 Igor Sukhih <igor@parallels.com> 7.0.158
 - The swap size mismatches expected value #PSBM-42705

* Fri Dec 25 2015 Igor Sukhih <igor@parallels.com> 7.0.157
 - vcmm: remove set deprecated VCMMD_VE_CONFIG_MAX_LIMIT parameter

* Thu Dec 24 2015 Igor Sukhih <igor@parallels.com> 7.0.156
 - fixed compilation warning

* Thu Dec 24 2015 Igor Sukhih <igor@parallels.com> 7.0.155
 - vz-cpt: store dump to temporary dir
 - revert "Allow access to /dev/autofs inside CT #PSBM-41218" (#PSBM-41219)
 - Use libvcmmd to operate on Container memory parameters #PSBM-42524

* Wed Dec 23 2015 Igor Sukhih <igor@parallels.com> 7.0.154
 - Create /dev/autofs inside CT #PSBM-41218
 - Allow access to /dev/autofs inside CT #PSBM-41218

* Wed Dec 23 2015 Igor Sukhih <igor@parallels.com> 7.0.153
 - Unable to resume CT #PSBM-42641
 - Node hostname is visible inside CT #PSBM-42592

* Tue Dec 22 2015 Igor Sukhih <igor@parallels.com> 7.0.152
 - CT start failed with enabled 2quota #PSBM-42569

* Tue Dec 22 2015 Igor Sukhih <igor@parallels.com> 7.0.151
 - vz-start: nfsv4 is not autoloaded on nfs feature enabled #PSBM-42476

* Mon Dec 21 2015 Igor Sukhih <igor@parallels.com> 7.0.150
 - Pass --cgroup-root option to criu during restore

* Mon Dec 21 2015 Igor Sukhih <igor@parallels.com> 7.0.149
 - Setup sysfs permissions for root disk #PSBM-42369

* Wed Dec 16 2015 Igor Sukhih <igor@parallels.com> 7.0.148
 - Unable to create CT with --no-hdd option #PSBM-42416
 - Added bandwidth to vz-stop script (for tc class removal), #PSBM-42393 
 - Fixed regression in vz-setrate, #PSBM-42361

* Mon Dec 14 2015 Igor Sukhih <igor@parallels.com> 7.0.147
 - fs_is_mounted_check_by_target: inverted result #PSBM-42347

* Fri Dec 11 2015 Igor Sukhih <igor@parallels.com> 7.0.146
 - Resurrect simfs CT #PSBM-40726

* Thu Dec 10 2015 Igor Sukhih <igor@parallels.com> 7.0.145
 - Two CT's with the same name #PSBM-41988

* Thu Dec 10 2015 Igor Sukhih <igor@parallels.com> 7.0.144
 - Failed to create CT if config file exists #PSBM-42203

* Wed Dec 09 2015 Igor Sukhih <igor@parallels.com> 7.0.143
 - vzctl_check_owner_quiet: skip check if VE_PRIVATE does not exists #PSBM-42186

* Tue Dec 08 2015 Igor Sukhih <igor@parallels.com> 7.0.142
 - destroydir: do not close lock fd

* Mon Dec 07 2015 Igor Sukhih <igor@parallels.com> 7.0.141
 - remove debug code #PSBM-41900

* Fri Dec 04 2015 Igor Sukhih <igor@parallels.com> 7.0.140
 - Failed to suspend CT: Can't dump ghost file /run/log/journal #PSBM-41900

* Thu Dec 03 2015 Igor Sukhih <igor@parallels.com> 7.0.139
 - vzlist: cpulimit rounding #PSBM-41947

* Thu Dec 03 2015 Igor Sukhih <igor@parallels.com> 7.0.138
 - vzctl2_exec_script: redirect all script output to stderr
 - vzerror: rederect error message to stderr

* Wed Dec 02 2015 Igor Sukhih <igor@parallels.com> 7.0.137
 - vzctl2_get_env_status_info: request fast mount check by demand #PSBM-41777

* Mon Nov 30 2015 Igor Sukhih <igor@parallels.com> 7.0.136
 - Incorrect value for VZCTL_CONF_RUNTIME_PARAM flag #PSBM-41693

* Fri Nov 27 2015 Igor Sukhih <igor@parallels.com> 7.0.135
 - undefined symbol: vzctl2_env_get_cap #PSBM-41681

* Fri Nov 27 2015 Igor Sukhih <igor@parallels.com> 7.0.134
 - remove processing capability parameter #PSBM-40834

* Wed Nov 25 2015 Igor Sukhih <igor@parallels.com> 7.0.133
 - failed to create /var/lock/vzctl/: File exists #PSBM-41523
 - ns_get_runtime_param: collect IO parameters
 - Get cpulimit runtime settings #PSBM-41333

* Thu Nov 19 2015 Igor Sukhih <igor@parallels.com> 7.0.132
 - vzctl2_env_get_disk_stats: collect mountpoints for disk

* Wed Nov 11 2015 Igor Sukhih <igor@parallels.com> 7.0.131
 - vzctl_popen: specify close std flags
 - Failed to create CT on centos-7 ostemplate #PSBM-41191

* Wed Nov 11 2015 Igor Sukhih <igor@parallels.com> 7.0.130
 - Provide ro perm to CT root device #PSBM-40986

* Tue Nov 10 2015 Igor Sukhih <igor@parallels.com> 7.0.129
 - Run vz-start script before CT start

* Fri Nov 06 2015 Igor Sukhih <igor@parallels.com> 7.0.127
 - Redesign the get CT running state logic #PSBM-40969
 - Load veth module on CT start/resume

* Thu Nov 05 2015 Igor Sukhih <igor@parallels.com> 7.0.126
 - Failed to switch to snapshot for runing CT #PSBM-40986
 - Mount simfs based CT #PSBM-40726

* Mon Nov 02 2015 Igor Sukhih <igor@parallels.com> 7.0.125
 - Become a session leader before starting container's init #PSBM-40959
 - Use ip_nonlocal_bind only for arp announce  #PSBM-40525

* Tue Oct 27 2015 Igor Sukhih <igor@parallels.com> 7.0.124
 - vznetcfg: bring up veth iface

* Tue Oct 27 2015 Igor Sukhih <igor@parallels.com> 7.0.123
 - Export vzctl2_set_tc_param() #PSBM-40697

* Tue Oct 27 2015 Igor Sukhih <igor@parallels.com> 7.0.122
 - Unable to restore CT with configured veth
 - Revert commit ed71a789 "Add creation of venet on restore"

* Mon Oct 26 2015 Igor Sukhih <igor@parallels.com> 7.0.121
 - Resize secondary disk mounted inside CT #PSBM-39492
 - Skip store autogenerated root disk into CT configuration
 - Skip veth device creation on CT restore
 - Skip veth iface configure inside CT on resume
 - Skip venet0 iface configure inside CT on resume

* Sat Oct 24 2015 Igor Sukhih <igor@parallels.com> 7.0.120
 - Remove node venet0 iface creation logic #PSBM-40624
 - Rework CT suspend/resume logic #PSBM-40202 #PSBM-34803

* Fri Oct 23 2015 Igor Sukhih <igor@parallels.com> 7.0.119
 - scripts: Add creation of venet on restore, #PSBM-40089
 - Failed to start CT #PSBM-40608

* Fri Oct 23 2015 Igor Sukhih <igor@parallels.com> 7.0.118
 - Move task to CT systemd cgroup on exec/enter action #PSBM-40284
 - SIGSEGV in vztmpl_install_app() #PSBM-40578
 - Use ip_nonlocal_bind setting to arp announce #PSBM-40322

* Tue Oct 20 2015 Igor Sukhih <igor@parallels.com> 7.0.117
 - CT resources are not released on CT destroy, #PSBM-39001
 - vzctl2_umount_snapshot: umount in reverse order
 - File system is not mounted on 'snapshot-mount' action, #PSBM-38423

* Mon Oct 19 2015 Igor Sukhih <igor@parallels.com> 7.0.116
 - Unable to login to CT by ssh: Connection closed, #PSBM-40245, #PSBM-34433

* Fri Oct 16 2015 Igor Sukhih <igor@parallels.com> 7.0.115
 - Setup venet device on node #PSBM-40255
 - Manage venet device via netlink #PSBM-40255
 - Deny rw access to secondary ploop inside CT #PSBM-34497

* Tue Oct 13 2015 Igor Sukhih <igor@parallels.com> 7.0.114
 - Negate return value of arping#PSBM-39271

* Fri Oct 09 2015 Igor Sukhih <igor@parallels.com> 7.0.113
 - Store autogenerated veth host_ifname parameter #PSBM-39735
 - Save custom names of veth pair host end.
 - Change defaut veth host iface name generation schema
 - enable_disk: unmount disk if setup op failed

* Thu Oct 08 2015 Igor Sukhih <igor@parallels.com> 7.0.111
 - Do not restrict capabilities for CT #PSBM-40232 #PSBM-40067

* Tue Oct 06 2015 Igor Sukhih <igor@parallels.com> 7.0.110
 - Turn off sending StartTransientUnit event #PSBM-40198
 - Attach to user namespace on enter
 - Update Ploop calls to newer API

* Tue Oct 06 2015 Igor Sukhih <igor@parallels.com> 7.0.109
 - Remove Slice from DBUS message, fixes
 - create_perctl_symlink: create relative symlink, #PSBM-38634

* Mon Oct 05 2015 Igor Sukhih <igor@parallels.com> 7.0.108
 - Update DISKSPACE parameter on root image resize #PSBM-39496
 - Remove CT init pidfile on suspend
 - CT resume faile dif teher no /var/run/ve folder #PSBM-40125

* Fri Oct 02 2015 Igor Sukhih <igor@parallels.com> 7.0.107
 - Uid/Gid 1:1 mapping breaks SSH service in guest #PSBM-40061
 - notify host's systemd instance about VE unit upon its start, #PSBM-33825

* Tue Sep 29 2015 Igor Sukhih <igor@parallels.com> 7.0.106
 - Failed to start CT: broken by 0032828d
 - cpt failed with a session leader is outside of its pid namespace #PSBM-39514

* Tue Sep 29 2015 Igor Sukhih <igor@parallels.com> 7.0.105
 - Fixed compilation

* Mon Sep 28 2015 Igor Sukhih <igor@parallels.com> 7.0.104
 - Remount container root as a shared at the very end #PSBM-34698 (#PSBM-34698)
 - Normalized VE_PRIVATE stored to VEID.conf on CT create/register #PSBM-39917

* Mon Sep 28 2015 Igor Sukhih <igor@parallels.com> 7.0.103
 - Enable user namespace inside Containers: 1:1 user mapping #PSBM-39301
 - Create per cgroup symlink inside CT #PSBM-38634

* Fri Sep 25 2015 Igor Sukhih <igor@parallels.com> 7.0.102
 - Cannot rmdir 'system.slice: Device or resource busy' #PSBM-39914
 - Remove existing veth interfaces on container start, #PSBM-39081

* Wed Sep 23 2015 Igor Sukhih <igor@parallels.com> 7.0.101
 - Two entries created under /sys/fs/cgroup/systemd/ directory

* Wed Sep 09 2015 Sergey Galas' <shrike@odin.com> 7.0.100
 - freezer is not a private cgroup anymore. need this to run docker 1.8.1 on VZ7
as docker tries to attach docker-container to this hierarchy. (Sergey Galas
<shrike@odin.com>)
 - Removed IPV6 config param check from vz-setrate, #PSBM-39105 (Maxim
Perevedentsev <mperevedentsev@parallels.com>)
 - read_init_pid: surpress ENOENT error message (Igor Sukhih
<igor@parallels.com>)
 - write_init_pid: display error on file creation failure (Igor Sukhih
<igor@parallels.com>)

* Fri Aug 21 2015 Igor Sukhih <igor@parallels.com> 7.0.98
 - Failed to start CT #PSBM-38994

* Thu Aug 20 2015 Igor Sukhih <igor@parallels.com> 7.0.96
 - Create systemd unit only on Container start. On already started Container
 - Attach forked process on enter to container's systemd slice, #PSBM-38940
 - Bind mount from host is not visible insize CT #PSBM-38933
 - Customize vz-rst action script, #PSBM-37923

* Tue Aug 18 2015 Igor Sukhih <igor@parallels.com> 7.0.95
 - Save/restore ct init pid to ve_private/init.pid, #PSBM-37928
 - Mount rootfs as a private once cgroups are passed into container#PSBM-34698
 - Fixed shaping settings parsing.
 - Fix possible collisions in ethtool output, #PSBM-18138.
 - Moved RATEMPU to optional parameters, #PSBM-17708

* Fri Aug 07 2015 Igor Sukhih <igor@parallels.com> 7.0.94
 - Add TSO/HWCSUM settings propogation from master to slave #PSBM-18138
 - Update /etc/hostname on every hostname change #PSBM-33996
 - scripts/vz-functions.in: Do not set metric=1000 for venet0 route
 - scripts/vz-functions.in: remove unused code

* Wed Jul 29 2015 Igor Sukhih <igor@parallels.com> 7.0.93
 - Delete disk failed if mounted inside CT
 - Cleanup sysfs permission on disk deletion, #PSBM-35160

* Wed Jul 29 2015 Igor Sukhih <igor@parallels.com> 7.0.92
 - CT start failed with enabled traffic shaping, #PSBM-35264
 - Fixed checking mouted state for disk with device type, #PSBM-35018

* Mon Jul 27 2015 Igor Sukhih <igor@parallels.com> 7.0.91
 - vzctl2_get_envid_by_name(): Extend logic to handle both CTID & NAME,
#PSBM-35201

* Fri Jul 24 2015 Igor Sukhih <igor@parallels.com> 7.0.90
 - Create devnodes on CT start, #PSBM-35146

* Fri Jul 24 2015 Igor Sukhih <igor@parallels.com> 7.0.89
 - Release snapshot tree
 - beancounter.h: remove local copy, use stock one
 - configure.ac: add check for vz kernel headers
 - lib/include/linux/vzctl_netstat.h: remove
 - dists/Makefile.am: remove dup
 - configure.ac/Makefiles: remove unused stuff
 - lib/Makefile.am: use $(UTIL_LIBS)
 - configure.ac: checks for ploop
 - configure.ac: add checks for libvzevent
 - configure.ac: check for libuuid, set LIBS
 - libvzctl: untangle linking with libxml2

* Thu Jul 23 2015 Igor Sukhih <igor@parallels.com> 7.0.88
 - Fixed path to custom scripts
 - Custop reinstall does not work, #PSBM-35142
 - custom_reinstall(): define args in array definition
 - lsblk is not work inside CT, #PSBM-34749

* Wed Jul 22 2015 Igor Sukhih <igor@parallels.com> 7.0.87
 - Unable to create snapshot on running CT
 - Failed to restore CT
 - Change in devnodes configuring process for compatibility, #PSBM-33885

* Tue Jul 21 2015 Igor Sukhih <igor@parallels.com> 7.0.86
 - Move network device from host to CT, #PSBM-35084

* Tue Jul 21 2015 Igor Sukhih <igor@parallels.com> 7.0.85
 - Rollback f536c48c, #PSBM-35076

* Tue Jul 21 2015 Igor Sukhih <igor@parallels.com> 7.0.84
 - CT reinstall failed, #PSBM-33856
 - cpumask doesn't work for CTs, #PSBM-34817

* Mon Jul 20 2015 Igor Sukhih <igor@parallels.com> 7.0.83
 - False positive error displayed if there no cached ostemplate, #PSBM-34984
 - Create CT veth pair on restore
 - Incorrect memory limit is set. #PSBM-35005
 - Freeze CT on force stop action
 - Resume CT on stop action if in frozen state
 - Enter into freezer cgroup

* Thu Jul 16 2015 Igor Sukhih <igor@parallels.com> 7.0.82
 - Kill CT init on fast stop, #PSBM-34881
 - Autogenerated veth host intarface name is stored in CT configuration
 - generate_veth_name(): decrease number of arguments
 - parse_ub:  Failed to register CT with "unlimited" parameters, #PSBM-34913
 - scripts/vz-start.in: rm unused variable
 - scripts/vz-start.in: print error to stderr
 - scripts/vz-start.in: add nfs and nfsd autoloading
 - scripts/vz-start.in: add bridge autoloading
 - scripts/vz-start.in: improve ppp processing
 - scripts/vz-start.in: saner config checking
 - scripts/vz-start.in: fix not loading tun
 - scripts/vz-start.in: fix comments

* Wed Jul 15 2015 Igor Sukhih <igor@parallels.com> 7.0.81
 - Failed to register CT with "unlimited" parameters, #PSBM-34913

* Wed Jul 15 2015 Igor Sukhih <igor@parallels.com> 7.0.80
 - exec is not detached for command running in background, #PSBM-34835
 - test: fixes/improvements
 - Display ctid on create failure
 - Inconsistent host_mac in config and on node, #PSBM-34904

* Wed Jul 15 2015 Igor Sukhih <igor@parallels.com> 7.0.79
 - Failed to start the Container with Host-Only network, #PSBM-34885

* Tue Jul 14 2015 Igor Sukhih <igor@parallels.com> 7.0.78
 - Container registration failed: Container is already registered, #PSBM-34887
 - Error on CT start "Error in waitpid(180985): No child processes", #PSBM-34878

* Mon Jul 13 2015 Igor Sukhih <igor@parallels.com> 7.0.77
 - Perform systemd-tmpfiles-setup-dev.service modification on CT start only
 - Device is not create id specified with dir, #PSBM-34864
 - It possible to register second copy of already existing Container,
#PSBM-34859
 - remove_tmpfiles_caps: minor code cleanup

* Fri Jul 10 2015 Igor Sukhih <igor@parallels.com> 7.0.76
 - Add vzctl2_env_get_disk_stats() function, #PSBM-33852
 - Display parameter name in warning message
 - vzctl_check_ub: CT start failed with UB based configuration, #PSBM-34833
 - Drop CT dump state on start action, #PSBM-34827
 - cg_get_ctl: Eliminate debug message "cgroup %s mount point: %s"
 - vzctl2_env_restore: Removu duplicate 'apply_quota_param' call

* Thu Jul 09 2015 Igor Sukhih <igor@parallels.com> 7.0.75
 - vznetcfg: Use vnetwork as bridge name if bound is iface empty, #PSBM-34812
 - create_tmpfiles: Device with subdir created in /dev, #PSBM-34788
 - Eliminate double vzctl2_env_exec_fn for finalize disk configuration
 - create_root_dev: Remove clean_static_dev() call
 - setup_env_quota: Remove create_root_dev() call
 - env_fin_configure_systemd_unit: Exit with error on success
 - is_existing_ploop: Operation on NULL pointer, #PSBM-34793

* Tue Jul 07 2015 Igor Sukhih <igor@parallels.com> 7.0.74
 - Return back CAP_SYS_ADMIN | CAP_NET_ADMIN, #PSBM-34741

* Mon Jul 06 2015 Igor Sukhih <igor@parallels.com> 7.0.73
 - init_env_cgroup: Add 'rw' access to /dev/tun
 - init_env_cgroup: Give 'w' access to /dev/random
 - vzauth: perform crypt(3) on the host side, #PSBM-34647

* Mon Jul 06 2015 Igor Sukhih <igor@parallels.com> 7.0.72
 - Failed to mount /proc: Operation not permitted

* Mon Jul 06 2015 Igor Sukhih <igor@parallels.com> 7.0.71
 - CAP_SYS_ADMIN & CAP_NET_ADMIN are allowed by default, #PSBM-34717
 - Eliminate local variable.
 - Deny /sys/block inside CT, #PSBM-33064

* Fri Jul 03 2015 Igor Sukhih <igor@parallels.com> 7.0.70
 - Rollback commit ed7dc432 "vzctl2_lock: CID 121541 Resource leak", #PSBM-34702
 - If RATEMPU is undeclared, vz-setrate fills its dev:class from TOTALRATE.

* Fri Jul 03 2015 Igor Sukhih <igor@parallels.com> 7.0.69
 - CID 122056 Resource leak (RESOURCE_LEAK)
 - vztmpl_install_app: CID 121572 Resource leak (RESOURCE_LEAK)
 - add_bindmount: CID 121558 Resource leak (RESOURCE_LEAK)
 - read_env_transition: CID 121585 Out-of-bounds write (OVERRUN)
 - vzctl2_env_layout_version: CID 121566 Out-of-bounds write (OVERRUN)
 - subst_VEID: CID 121571 Out-of-bounds read (OVERRUN)
 - get_user_pw: CID 121559 Out-of-bounds read (OVERRUN)13
 - env_param2str: CID 121552 Missing break in switch (MISSING_BREAK)
 - vzctl_store_snapshot_tree: CID 121542 Logically dead code (DEADCODE)
 - CID 121590 Explicit null dereferenced (FORWARD_NULL)
 - vzctl2_env_create: CID 121593 Destination buffer too small (STRING_OVERFLOW)
 - parse_disk: CID 121556 Dereference null return value (NULL_RETURNS)
 - create_static_dev: CID 121554 Dereference before null check (REVERSE_INULL)
 - vzctl2_env_create: CID 121553 Dereference before null check (REVERSE_INULL)
 - vzctl2_env_set_veth_param: CID 121548 Dereference before null check
(REVERSE_INULL)
 - wait_on_fifo: CID 122055 Argument cannot be negative (NEGATIVE_RETURNS)
 - vzctl2_get_name: CID 122059 Dereference before null check (REVERSE_INULL)
 - vzctl2_env_open_conf: CID 122056 Resource leak (RESOURCE_LEAK)
 - destroydir: CID 122057 Resource leak (RESOURCE_LEAK)
 - ns_apply_res_param: CID 122058 Resource leak (RESOURCE_LEAK)
 - vzctl2_scan_private: CID 122061 Use after free (USE_AFTER_FREE)
 - Use ret inverse
 - Calculate len once, check for stat() errno instead of access()
 - Use stat() to preserve owner/mode
 - Unneeded return removed
 - Remove CAP_SYS_MODULE capability from systemd-tmpfiles-setup-dev unit, see
#PSBM-34665
 - restore_FN: CID 121597: Uninitialized scalar variable (UNINIT)
 - ns_set_memory_param: CID 121594  Uninitialized scalar variable (UNINIT)
 - exec_init: CID 121587 Resource leak (RESOURCE_LEAK)
 - Add workaround for criu bug in container suspension, #PSBM-34667 (Nikita
Spiridonov <nspiridonov@odin.com>)
 - Unmount container during suspension, #PSBM-34667 (Nikita Spiridonov
<nspiridonov@odin.com>)
 - wait_on_fifo: CID 121583 Resource leak (RESOURCE_LEAK)
 - get_mnt_root: CID 121581 Resource leak (RESOURCE_LEAK)
 - parse_netif_cmd: CID 121567 Resource leak (RESOURCE_LEAK)
 - add_bindmount: CID 121558 Resource leak (RESOURCE_LEAK)
 - vzctl_free_snapshot_treeL ID 121555 Resource leak (RESOURCE_LEAK)
 - vzctl2_lock: CID 121541 Resource leak (RESOURCE_LEAK)
 - fs_is_mounted_check_by_dev: CID 121578 Dereference after null check
(FORWARD_NULL)
 - cmp_stat: CID 121539 Big parameter passed by value
(PASS_BY_VALUE)pass_by_value
 - make_bash_env: CID 121546 (#1 of 1): Array compared against 0 (NO_EFFECT)
 - replace_reach_runlevel_mark: CID 121545 Argument cannot be negative
(NEGATIVE_RETURNS)
 - vzctl_popen: CID 121543 Argument cannot be negative (NEGATIVE_RETURNS)
 - get_online_cpumask: CID 121611 Untrusted value as argument (TAINTED_SCALAR)
 - CID 121563 (#1 of 1): Unsigned compared against 0 (NO_EFFECT)
 - CID 121551 Unsigned compared against 0 (NO_EFFECT)
 - CID 121607 Double close (USE_AFTER_FREE)
 - CID 121610 (#1 of 1): Uninitialized scalar variable (UNINIT)

* Thu Jul 02 2015 Konstantin <wolf@parallels.com> 7.0.68
 - Remove CAP_SYS_MODULE capability from systemd-tmpfiles-setup-dev unit, see
#PSBM-34665
 - Requires:      criu (Igor Sukhih <igor@parallels.com>)

* Thu Jul 02 2015 Igor Sukhih <igor@parallels.com> 7.0.67
 - vzctl2_env_set_veth_param: double free on error
 - vzctl2_env_set_veth_param(): failed, #PSBM-34648
 - 64bit arch is reported inside 32bit CT, #PSBM-34596
 - vzctl2_get_name: Return CT name as is, #PSBM-34637
 - Unable to get ctid by name for UUID based CT
 - Store VEID=CTID in CT configuratuin on register

* Wed Jul 01 2015 Igor Sukhih <igor@parallels.com> 7.0.66
 - CT start failed with enabled traffic shaping

* Wed Jul 01 2015 Igor Sukhih <igor@parallels.com> 7.0.65
 - run_net_script: fill VE_STATE environmen variable
 - ARP proxy entry is not cleared, #PSBM-34603
 - Remove destroy vzcache logic
 - vzctl2_env_register: uuid parameter is not applied, #PSBM-34600

* Wed Jul 01 2015 Igor Sukhih <igor@parallels.com> 7.0.64
 - Fails to destroy CT cgroup if there are sub-cgroups, #PSBM-33925 #PSBM-34613

* Tue Jun 30 2015 Igor Sukhih <igor@parallels.com> 7.0.63
 - There no ploop device entry if hdd added without --mnt, #PSBM-34607
 - announce_ips: use enter_net_ns() to enter to net namespace
 - It possibly to change mac addres inside CT, #PSBM-34313
 - Allow virtual terminals to use inside container, #PSBM-34583
 - Update bash prompt on enter

* Mon Jun 29 2015 Igor Sukhih <igor@parallels.com> 7.0.62
 - Randomize file system uuid on CT creation, #PSBM-34531
 - Replace arpsend by arping, #PSBM-25351
 - Added RATEMPU check to vzcheck_TOTALRATE
 - Added RATEMPU parameter to vz-setrate for packet rate limitation
 - CT cgroups should be destroyed after 'vcmmdctl unregister', #PSBM-34525
 - Made bandwidth rate optional

* Fri Jun 26 2015 Igor Sukhih <igor@parallels.com> 7.0.61
 - Do not remove directory if exists on CT create
 - clean_dev_file: call opendir(NULL) resulted to SIGSEGV, #PSBM-34519
 - Tweak criu calls in vz-cpt and vz-rst scripts 

* Thu Jun 25 2015 Igor Sukhih <igor@parallels.com> 7.0.60
 - Create static ploop device entries, #PSBM-33800 #PSBM-34379
 - Clean static ploop devices records on CT start
 - The /etc/tmpfiles.d is not cleaned on CT start
 - Set 'rw' access to /sys/call/block/ploopNp1/uevent
 - Deprecate per CT sockbuf related limits, #PSBM-34490

* Thu Jun 25 2015 Igor Sukhih <igor@parallels.com> 7.0.59
 - Do not change VE_PRIVATE on register action
 - Unable to mount ploop inside CT
 - Send event on add new ploop device, #PSBM-33646
 - Preserve old uuid on CT register if new one is not specified, #PSBM-33769
 - get_env_ids_exists: duplicate ctid entries

* Wed Jun 24 2015 Igor Sukhih <igor@parallels.com> 7.0.58
 - Fill ve.veid in correct order, #PSBM-34465
 - Add vzctl2_env_get_veid
 - Use vz specific ioctl to get tc base

* Tue Jun 23 2015 Igor Sukhih <igor@parallels.com> 7.0.57
 - Rollback 99e22e0d "ns_env_create: remove 'struct start_param.pid' member"

* Tue Jun 23 2015 Igor Sukhih <igor@parallels.com> 7.0.56
 - Configure sysfs perm for secondary ploop, #PSBM-34415
 - set_ns: dipslay errno on open() failure
 - vzctl2_exec_script: remove close all fd logic
 - Fix criu restore flags in scripts/vz-rst

* Mon Jun 22 2015 Igor Sukhih <igor@parallels.com> 7.0.55
 - Set veid from userspace, #PSBM-34384

* Fri Jun 19 2015 Igor Sukhih <igor@parallels.com> 7.0.54
 - 'vzctl exec' inherent capabilities from parent task, #PSBM-33916

* Thu Jun 18 2015 Igor Sukhih <igor@parallels.com> 7.0.53
 - Stop CT from inside on 'vzctl stop VEID --fast'
 - Sometime "CTis locked error" appears, #PSBM-34283
 - Log output from script to logfile

* Wed Jun 17 2015 Igor Sukhih <igor@parallels.com> 7.0.52
 - Veth iface is in down state inside CT if ip/dhcp is not configured, #PSBM-34271
 - CT stop timeout does not work
 - Add README (Sergey Bronnikov <sergeyb@openvz.org>)

* Tue Jun 16 2015 Igor Sukhih <igor@parallels.com> 7.0.51
 - Unable to switch from dhcp to static ip, #PSBM-34254
 - Update virtual network for running CT
 - Change logic to get configured veth device name
 - Use new API to set mac filter parameter
 - Remove vzcalluser.h
 - Return io specific code in case error
 - Setup ioprio parameter, #PSBM-32281

* Mon Jun 15 2015 Igor Sukhih <igor@parallels.com> 7.0.50
 - Attach veth pair to virtual network
 - Process veth configureation parameters, #PSBM-34191

* Thu Jun 11 2015 Igor Sukhih <igor@parallels.com> 7.0.49
 - Cannot lock the Container, #PSBM-34052
 - Do not fail on ioprio set
 - Bind beancounter with blkio/memory cgroups, #PSBM-34082

* Wed Jun 10 2015 Igor Sukhih <igor@parallels.com> 7.0.48
 - Second level quota does not work. #PSBM-33895
 - Fail to set physpages to unlimited, #PSBM-34157
 - CT start in wait mode exited with timeout for inittab based CT, #PSBM-34159
 - Install headers with `make install', #PSBM-33975

* Tue Jun 09 2015 Igor Sukhih <igor@parallels.com> 7.0.47
 - Support "all" syntax for --devices, #PSBM-34064
 - Incorrect ioprio displayed, #PSBM-33988
 - vzauth: exit with special code if guid check failed, #PSBM-33957

* Tue Jun 09 2015 Igor Sukhih <igor@parallels.com> 7.0.46
 - add_inittab_entry: error logging enhancement
 - CT start in wait mode exited with timeout for inittab based CT, #PSBM-34130
 - Added IOPRIO functionality, #PSBM-33988, #PSBM-33946 #PSBM-32281
 - vzctl does not attach to blkio cgroup, #PSBM-34125
 - Setup CT console functionality

* Fri Jun 05 2015 Igor Sukhih <igor@parallels.com> 7.0.45
 - Enable 'ro' support for bindmount
 - Bindmount functionality does not work, #PSBM-34062 #PSBM-33834
 - increase log level for debug message 'cgroup %s mount point:'

* Fri Jun 05 2015 Igor Sukhih <igor@parallels.com> 7.0.44
 - vzt-vzctl-debug: creating.unexistent-config ERROR, #PSBM-33838
 - Invalid parameter for --devices "b:major:minor:none", #PSBM-33845
 - Add lz4 decompression support to vz-create_prvt script, #PSBM-33992

* Thu Jun 04 2015 Igor Sukhih <igor@parallels.com> 7.0.43
 - CT start hang

* Wed Jun 03 2015 Igor Sukhih <igor@parallels.com> 7.0.42
 - Add vzctl2_get_normalized_uuid definition to libvzctl.h
 - Updated git source URL
 - Process is not in the CT context on exec, #PSBM-33948 #PSBM-33893
 - provide more memory statistics

* Mon Jun 01 2015 Dmitry Mishin <dim@parallels.com> 7.0.41
 - Added copyright and license headers

* Mon Jun 01 2015 Igor Sukhih <igor@parallels.com> 7.0.40
 - Remove copy of linux header

* Sat May 30 2015 Konstantin Volkov <wolf@parallels.com> 7.0.39
 - --fast-links is vztar option, drop it
 - Drop supplementary groups on enter. (Igor Sukhih <igor@parallels.com>)
 - There no error message in case disk configuratin failed (Igor Sukhih <igor@parallels.com>)

* Fri May 29 2015 Igor Sukhih <igor@parallels.com> 7.0.38
 - CT is not accessible by network after restart. #PSBM-33868
 - Host routed ip addresses remain in route table after CT stop, #PSBM-33865
 - ns_env_stop: Uncomment drop iolimit code on force CT stop
 - Remove debug logging
 - generate_veth_name: LEading zero in veth iface name, #PSBM-33883
 - Can't start CT from volume created by cinder based on ploop image, #PSBM-33881
 - validate_eid: Unable to regisetr CT

* Thu May 28 2015 Igor Sukhih <igor@parallels.com> 7.0.37
 - Bind mounts are not visible inside CT, fixed #PSBM-33215
 - Create CT with existing ID, fixed #PSBM-33842
 - Unexpected exit status on CT creation with unknown ostemplate name, fixed #PSBM-33836
 - Change iolimit/iopslimit parameter type from int to uint

* Wed May 27 2015 Igor Sukhih <igor@parallels.com> 7.0.36
 - scripts: vz-rst -- Update parameters
 - move CT to systemd slice
 - Change iolimit/iopslimit parameter type  from int to uint
 - Remove deprecated ioprio parameter
 - Use cgroup iface to setup {io/iops}limit

* Tue May 26 2015 Igor Sukhih <igor@parallels.com> 7.0.35
 - Added vzctl2_env_get_ctid()
 - Deny CT creation with busy VEID
 - Can't start CT after set cpumask, #PSBM-33780

* Mon May 25 2015 Igor Sukhih <igor@parallels.com> 7.0.34
 - Add VZCTL_PARAM_BINDMOUNT_DEL paramater, #PSBM-33722
 - Incorrect cpulimit is setted, #PSBM-33728
 - Invalid exit code while creating new VE with existing ID. #PSBM-33733
 - Failed to create CT on ostemplate with leading '.', #PSBM-33740
 - Remove oomguarpages parameter
 - Double cpu parameter set on CT start
 - KMEMSIZE and DCACHESIZE is deprecated, #PSBM-33625
 - Remove license related code

* Fri May 22 2015 Igor Sukhih <igor@parallels.com> 7.0.33
 - KMEMSIZE and DCACHESIZE is deprecated
 - Remove license related code

* Thu May 21 2015 Igor Sukhih <igor@parallels.com> 7.0.32
 - Do not set kmem limit
 - Remove set oomguarpages parameter
 - Set container memory/swap limit via vcmmd
 - Unable to create CT if there no installed ostemplate
 - Remove incorrect message on CT create

* Thu May 21 2015 Igor Sukhih <igor@parallels.com> 7.0.31
 - Setup osrelease from inside CT
 - check_requires: Deny to set features parameter on running CT
 - set_features: Use cgroup API to set features
 - CTID is not correctly logged in /val/log/vactl.log
 - set_virt_osrelease: Use cgroup API to set osrelease
 - start_container: Remove license related error message
 - configure_mount_opts: Use cgroup API to set disk mount opts

* Mon May 18 2015 Igor Sukhih <igor@parallels.com> 7.0.30
 - Deny to use negative VEID, see #PSBM-33550

* Mon May 18 2015 Igor Sukhih <igor@parallels.com> 7.0.28
 - create_tmpfiles: incorrect mode 'b' for character device, see #PSBM-33241

* Fri May 15 2015 Konstantin Volkov <wolf@parallels.com> 7.0.27
 - Create additional systemd mount units for secondary ploops, see #PSBM-33367

* Fri May 15 2015 Igor Sukhih <igor@parallels.com> 7.0.26
 - Bind mounts are not visible inside CT

* Thu May 14 2015 Igor Sukhih <igor@parallels.com> 7.0.25
 - Fixed compilation warnings
 - validate_env_name: validate name parameter
 - get_cid_uuid_pair: surpress error message
 - Kmem accounting for containers is not enabled if KMEMSIZE is mssing in config
 - get_cgroup_mounts: Multiple cgroup mountpoint
 - exec_wrap: Link with libuuid
 - scritps: rst -- Update criu params
 - scripts: cpt -- Update criu params
 - Detect CT name conflict in case numeric names

* Thu May 14 2015 Igor Sukhih <igor@parallels.com> 7.0.23
 - get_cgroup_mounts: Multiple cgroup mountpoint
 - exec_wrap: Link with libuuid
 - scritps: rst -- Update criu params
 - scripts: cpt -- Update criu params
 - Detect CT name conflict in case numeric names

* Wed May 13 2015 Igor Sukhih <igor@parallels.com> 7.0.22
 - Detect CT name conflict in case numeric names

* Tue May 12 2015 Igor Sukhih <igor@parallels.com> 7.0.21
 - support device for CT disk(s)

* Fri May 08 2015 Igor Sukhih <igor@parallels.com> 7.0.20
 - do_umount_submounts: handle ' (deleted' suffix

* Fri May 08 2015 Igor Sukhih <igor@parallels.com> 7.0.19
 - allow to use VEID as CT id

* Thu May 07 2015 Igor Sukhih <igor@parallels.com> 7.0.17
 - Rework container's cgroup mounting

* Tue May 05 2015 Igor Sukhih <igor@parallels.com> 7.0.16
 - increase libvzctl major version
 - ns_env_stop: destroy cgroup configuration on CT stop
 - updated get CT ip list functionality
 - change CT id form integer to uuid

* Tue Apr 28 2015 Igor Sukhih <igor@parallels.com> 7.0.15
 - ns_env_stop: destroy cgroup configuration on CT stop, see #PSBM-29895
 - exec.c: added VZCTL_FLAG_DONT_USE_WRAP flags

* Mon Apr 20 2015 Igor Sukhih <igor@parallels.com> 7.0.14
 - remove offline management stuff, see #PSBM-32946

* Thu Apr 16 2015 Konstantin Volkov <wolf@parallels.com> 7.0.13
 - Added Ubuntus systemd console support, see #PCLIN-32529

* Fri Apr 10 2015 Dmitry Mishin <dim@parallels.com> 7.0.12
 - Skip venet0 device while processing veth devices (#PSBM-32876)
   (Yuri Pudgorodsky <yur@odin.com>)

* Fri Apr 10 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.11
 - Added license text #PSBM-32882
 - Updated license to LGPLv2.1 #PSBM-32882

* Thu Apr 09 2015 Igor Sukhih <igor@parallels.com> 7.0.10
 - skip venet0 iface removal by veth logic

* Thu Apr 09 2015 Igor Sukhih <igor@parallels.com> 7.0.9
 - update get network devices logic

* Tue Apr 07 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.8
 - rebuild with ploop 7.0.x #PSBM-32811

* Fri Apr 03 2015 Igor Sukhih <igor@parallels.com> 7.0.7
 - update path to CT configuration folder

* Tue Mar 31 2015 Igor Sukhih <igor@parallels.com> 7.0.5
 - use cgroup iface for venet0 configure #PSBM-32728

* Mon Mar 30 2015 Konstantin Volkov <wolf@parallels.com> - 7.0.4-2
- Initial changelog entry
